package ch.psi.daq.queryrest.response.json;

import java.io.IOException;
import java.util.Iterator;
import java.util.stream.Stream;

import com.fasterxml.jackson.core.JsonGenerationException;
import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

public class JsonStreamSerializer extends StdSerializer<Stream<?>>{
   private static final long serialVersionUID = 4695859735299703478L;
   
   public JsonStreamSerializer() {
      super(Stream.class, true);
   }

   @Override
   public void serialize(Stream<?> stream, JsonGenerator jgen, SerializerProvider provider) throws IOException,
         JsonGenerationException {
      provider.findValueSerializer(Iterator.class, null).serialize(stream.iterator(), jgen, provider);
   }
}
